[CCode (cprefix = "Camel", lower_case_cprefix = "camel_")]
namespace Camel {
	[CCode (cheader_filename = "camel/camel.h", type_id = "camel_network_settings_get_type ()")]
	public interface NetworkSettings : Camel.Settings {
		public string get_auth_mechanism ();
		public unowned string dup_auth_mechanism ();
		public void set_auth_mechanism (string auth_mechanism);
		public string get_host ();
		public unowned string dup_host ();
		public void set_host (string host);
		public uint16 get_port ();
		public void set_port (uint16 port);
		public Camel.NetworkSecurityMethod get_security_method ();
		public void set_security_method (Camel.NetworkSecurityMethod method);
		public string get_user ();
		public unowned string dup_user ();
		public void set_user (string user);
		[NoAccessorMethod]
		public string auth_mechanism { get; set; }
		[NoAccessorMethod]
		public string host { get; set; }
		[NoAccessorMethod]
		public uint16 port { get; set; }
		[NoAccessorMethod]
		public string user { get; set; }
		[NoAccessorMethod]
		public Camel.NetworkSecurityMethod security_method { get; set; }
	}
	[CCode (cheader_filename = "camel/camel.h", cprefix = "CAMEL_NETWORK_SECURITY_METHOD_", type_id = "camel_network_security_method_get_type ()")]
	public enum NetworkSecurityMethod {
		NONE,
		SSL_ON_ALTERNATE_PORT,
		STARTTLS_ON_STANDARD_PORT
	}
	[CCode (cheader_filename = "camel/camel.h", type_id = "camel_settings_get_type ()")]
	public interface Settings : GLib.Object {
		public Camel.Settings clone ();
		public bool equal (Camel.Settings settings_b);
	}
}