[CCode (cprefix = "E", lower_case_cprefix = "e_")]
namespace E {
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_authentication_session_get_type ()")]
	public abstract class AuthenticationSession : GLib.Object {
		[CCode (has_construct_function = false)]
		private AuthenticationSession ();
		public E.SourceRegistryServer get_server ();
		public E.SourceAuthenticator get_authenticator ();
		public unowned string get_source_uid ();
		public unowned string get_prompt_title ();
		public string dup_prompt_title ();
		public void set_prompt_title (string prompt_title);
		public unowned string get_prompt_message ();
		public string dup_prompt_message ();
		public void set_prompt_message (string prompt_message);
		public unowned string get_prompt_description ();
		public string dup_prompt_description ();
		public void set_prompt_description (string prompt_description);
		public abstract E.AuthenticationSessionResult execute_sync (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public abstract async E.AuthenticationSessionResult execute (int io_priority, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool store_password_sync (string password, bool permanently, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool store_password (string password, bool permanently, int io_priority, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool lookup_password_sync (GLib.Cancellable? cancellable, out string password) throws GLib.Error;
		public async bool lookup_password (int io_priority, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool delete_password_sync (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool delete_password (int io_priority, GLib.Cancellable? cancellable = null) throws GLib.Error;
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", cprefix = "E_AUTHENTICATION_SESSION_", type_id = "e_authentication_session_result_get_type ()")]
	public enum AuthenticationSessionResult {
		ERROR,
		SUCCESS,
		DISMISSED
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_backend_get_type ()")]
	public abstract class Backend : GLib.Object {
		[CCode (has_construct_function = false)]
		private Backend ();
		public bool get_online ();
		public void set_online (bool online);
		public unowned E.Source get_source ();
		public GLib.SocketConnectable ref_connectable ();
		public void set_connectable (GLib.SocketConnectable connectable);
		public GLib.MainContext ref_main_context ();
		public bool authenticate_sync (E.SourceAuthenticator auth, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public void authenticate (E.SourceAuthenticator auth, GLib.Cancellable? cancellable = null);
		//public ETrustPromptResponse trust_prompt_sync (E.NamedParameters parameters, GLib.Cancellable? cancellable = null) throws Error;
		public void trust_prompt (E.NamedParameters parameters, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool get_destination_address (out string host, out uint16 port);
		public bool is_destination_reachable (GLib.Cancellable? cancellable = null) throws GLib.Error;
		[NoAccessorMethod]
		public GLib.SocketConnectable connectable { get; set; }
		[NoAccessorMethod]
		public GLib.MainContext main_context { get; }
		[NoAccessorMethod]
		public bool online { get; set construct; }
		[NoAccessorMethod]
		public E.Source source;
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_backend_factory_get_type ()")]
	public abstract class BackendFactory : E.Extension, E.Extensible {
		[CCode (has_construct_function = false)]
		private BackendFactory ();
		public string get_hash_key ();
		public E.Backend new_backend (E.Source source);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_collection_backend_get_type ()")]
	public class CollectionBackend : E.Backend {
		[CCode (has_construct_function = false)]
		private CollectionBackend ();
		public E.Source new_child (string resource_id);
		public E.SourceRegistryServer ref_server ();
		public unowned string get_cache_dir ();
		public string dup_resource_id (E.Source child_source);
		public GLib.List<E.Source> claim_all_resources ();
		public GLib.List<E.Source> list_calendar_sources ();
		public GLib.List<E.Source> list_contacts_sources ();
		public GLib.List<E.Source> list_mail_sources ();
		public bool create_resource_sync (E.Source source, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool create_resource (E.Source source, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool delete_resource_sync (E.Source source, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async bool delete_resource (E.Source source, GLib.Cancellable? cancellable = null) throws GLib.Error;
		[NoAccessorMethod]
		public string filename { get; construct; }
		public signal void child_added (E.ServerSideSource child_source);
		public signal void child_removed (E.ServerSideSource child_source);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_collection_backend_factory_get_type ()")]
	public class CollectionBackendFactory : E.BackendFactory {
		[CCode (has_construct_function = false)]
		private CollectionBackendFactory ();
		public class unowned string factory_name;
		public class GLib.Type backend_type;
		public virtual void prepare_mail (E.Source mail_account_source, E.Source mail_identity_source, E.Source mail_transport_source);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_data_factory_get_type ()")]
	public abstract class DataFactory : GLib.Object, E.Extensible {
		[CCode (has_construct_function = false)]
		private DataFactory ();
		public unowned E.Backend ref_backend (string hash_key, E.Source source);
		public unowned E.Backend ref_initable_backend (string hash_key, E.Source source, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public unowned E.BackendFactory ref_backend_factory (string hash_key);
		public signal void backend_created (E.Backend backend);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_dbus_server_get_type ()")]
	public abstract class DBusServer : GLib.Object, E.Extensible {
		[CCode (has_construct_function = false)]
		private DBusServer ();
		public E.DBusServerExitCode run (bool wait_for_client);
		public void quit (E.DBusServerExitCode code);
		public void hold ();
		public void release ();
		public void load_modules ();
		public signal void bus_acquired (GLib.DBusConnection connection);
		public signal void bus_name_acquired (GLib.DBusConnection connection);
		public signal void bus_name_lost (GLib.DBusConnection connection);
		public signal void quit_server (E.DBusServerExitCode code);
		public signal E.DBusServerExitCode run_server ();
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", cprefix = "E_DBUS_SERVER_EXIT_", type_id = "e_dbus_server_exit_code_get_type ()")]
	public enum DBusServerExitCode {
		NONE,
		NORMAL,
		RELOAD
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_extension_get_type ()")]
	public abstract class Extension : GLib.Object {
		[CCode (has_construct_function = false)]
		private Extension ();
		public unowned E.Extensible get_extensible ();
		public class GLib.Type extensible_type;
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_extensible_get_type ()")]
	public interface Extensible : GLib.Object {
		public abstract void load_extensions ();
		public abstract GLib.List<E.Extension> list_extensions (GLib.Type extension_type);
		public signal void bus_acquired (GLib.DBusConnection connection);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_file_cache_get_type ()")]
	public class FileCache : GLib.Object {
		public FileCache (string filename);
		public bool remove ();
		public bool clean  ();
		public string get_object (string key);
		public GLib.SList<string> get_objects ();
		public GLib.SList<string> get_keys ();
		public bool add_object (string key, string value);
		public bool replace_object (string key, string new_value);
		public bool remove_object (string key);
		public void freeze_changes ();
		public void thaw_changes ();
		public string get_filename ();
		[NoAccessorMethod]
		public string filename { get; construct; }
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_module_get_type ()")]
	public class Module : GLib.TypeModule, GLib.TypePlugin {
		[CCode (has_construct_function = false)]
		public Module ();
		public string get_filename ();
		public static GLib.List<E.Module> load_all_in_directory ();
		[NoAccessorMethod]
		public string filename { get; construct; }
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_cname = "EOAuth2SupportInterface", type_id = "e_oauth2_support_get_type ()")]
	public interface OAuth2Support : GLib.Object {
		public abstract bool get_access_token_sync (E.Source source, GLib.Cancellable? cancellable, out string? access_token = null, out int? expires_in = null) throws GLib.Error;
		public abstract async bool get_access_token (E.Source source, GLib.Cancellable? cancellable, out string? access_token = null, out int? expires_in = null) throws GLib.Error;
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_soup_auth_bearer_get_type ()")]
	public class SoupAuthBearer : Soup.Auth {
		[CCode (has_construct_function = false)]
		public SoupAuthBearer ();
		public void set_access_token (string access_token, int expires_in_seconds);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", cprefix = "E_SOURCE_PERMISSION_", type_id = "e_source_permission_flags_get_type ()")]
	[Flags]
	public enum SourcePermissionFlags {
		NONE,
		WRITABLE,
		REMOVABLE
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_source_registry_server_get_type ()")]
	public class SourceRegistryServer : GLib.Object, E.Extensible {
		[CCode (has_construct_function = false)]
		public SourceRegistryServer ();
		public void add_source (E.Source source);
		public void remove_source (E.Source source);
		public bool load_directory (string path, E.SourcePermissionFlags flags) throws GLib.Error;
		public bool load_resource (GLib.Resource resource, string path, E.SourcePermissionFlags flags) throws GLib.Error;
		public E.Source load_file (GLib.File file, E.SourcePermissionFlags flags) throws GLib.Error;
		public E.Source ref_source (string uid);
		public GLib.List<E.Source> list_sources (string extension_name);
		public E.Source find_extension (E.Source source, string extension_name);
		public E.CollectionBackend ref_backend (E.Source source);
		public E.CollectionBackendFactory ref_backend_factory (E.Source source);
		public E.AuthenticationSession new_auth_session (E.SourceAuthenticator authenticator, string source_uid);
		public bool authenticate_sync (E.AuthenticationSession session, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public async void authenticate (E.AuthenticationSession session, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public signal void files_loaded ();
		public signal void load_error (GLib.File file, GLib.Error error);
		public signal void source_added (E.ServerSideSource source);
		public signal void source_removed (E.ServerSideSource source);
		public signal bool tweak_key_file (GLib.KeyFile key_file, string uid);
	}
	[CCode (cheader_filename = "libebackend/libebackend.h", type_id = "e_server_side_source_get_type ()")]
	public class ServerSideSource : E.Source {
		[CCode (has_construct_function = false)]
		public ServerSideSource (E.SourceRegistryServer server, GLib.File file) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public ServerSideSource.memory_only (string uid) throws GLib.Error;
		public static string get_user_dir ();
		public static GLib.File new_user_file (string? uid);
		public static string uid_from_file (GLib.File file) throws GLib.Error;
		public bool load (GLib.Cancellable? cancellable = null) throws GLib.Error;
		public GLib.File get_file ();
		public GLib.Node<E.Source> get_node ();
		public E.SourceRegistryServer get_server ();
		public bool get_allow_auth_prompt ();
		public void set_allow_auth_prompt (bool allow_auth_prompt);
		public GLib.Type get_auth_session_type ();
		public void set_auth_session_type (GLib.Type auth_session_type);
		public bool get_exported ();
		public unowned string get_write_directory ();
		public void set_write_directory (string write_directory);
		public void set_removable (bool removable);
		public void set_writable (bool writable);
		public void set_remote_creatable (bool remote_creatable);
		public void set_remote_deletable (bool remote_deletable);
		public E.OAuth2Support ref_oauth2_support ();
		public void set_oauth2_support (E.OAuth2Support oauth2_support);
		[NoAccessorMethod]
		public bool allow_auth_prompt { get; set construct; }
		[NoAccessorMethod]
		public GLib.Type auth_session_type { get; set; }
		[NoAccessorMethod]
		public bool exported { get;}
		[NoAccessorMethod]
		public GLib.File file { get; construct; }
		[NoAccessorMethod]
		public E.OAuth2Support oauth2_support { get; set; }
		[NoAccessorMethod]
		public bool remote_creatable { get; set; }
		[NoAccessorMethod]
		public bool remote_deletable { get; set; }
		[NoAccessorMethod]
		public bool removable { get; set; }
		[NoAccessorMethod]
		public E.SourceRegistryServer server { get; construct; }
		[NoAccessorMethod]
		public bool writable { get; set; }
		[NoAccessorMethod]
		public string writable_directory { get; set; }
	}
}
